from concurrent.futures import process
import os
from turtle import color
import pandas as pd
from nltk.sentiment.vader import SentimentIntensityAnalyzer as SIA
from textblob import TextBlob
import datetime
import matplotlib.pyplot as plt
import numpy as np

def process_ticker_headlines(ticker, method):
    '''
    Function which takes in a stock ticker, loads its headlines from the text file generated from headline_scrape.py, and performs either VADER or TextBlob sentiment analysis. 
    Outputs headline, date, score to a csv file.
    ticker - string
    method - string 
    returns nothing
    '''
    #allow user to enter .txt or without it
    ticker_name = ticker
    if ticker.endswith('.txt') == False:
        ticker = ticker + '.txt'
    #check to see if it exists
    if os.path.exists('headlines/' + ticker):
        headline_collection = []
        with open('headlines/' + ticker, 'r', encoding="utf8") as f:
            headline_elements = f.readlines()
            count = 0
            end = len(headline_elements)
            #scan each line in the ticker file
            for headline in headline_elements:
                #progress tracker for user 
                percentage = count / end
                percentage = round(percentage * 100, 1)
                count = count + 1
                print("Progress: " + str(percentage) + "%", end="\r")
                #space separate line
                headline_array = headline.split(" ", 2)
                #apply sentiment
                if method == 'vader':
                    sentiment_score = SIA().polarity_scores(headline_array[2])['compound'] #compount is the polarity value for VADER
                    headline_collection.append([headline_array[0], headline_array[2], sentiment_score])
                elif method == 'textblob':
                    sentiment_score = TextBlob(headline_array[2]).sentiment.polarity
                    headline_collection.append([headline_array[0], headline_array[2], sentiment_score])
        #export as csv
        df = pd.DataFrame(headline_collection, columns=['Date', 'Headline', 'Sentiment Score'])
        if method == 'vader':
            df.to_csv(ticker_name + "_vader_data.csv", index=False)
        elif method == 'textblob':
            df.to_csv(ticker_name + "_textblob_data.csv", index=False)
    else:
        print("Error: ticker file does not exist.")
        return 

def display_ticker_data(ticker):
    '''
    Function which takes in a stock ticker, calculates the weekly average polarity for both VADER and TextBlob, plots it to a graph, and calculates the PMCC for the whole dataset.
    process_ticker_headlines must be called before this otherwise it won't work, as it reads in the csv file generated by that function.
    ticker - string
    '''
    vader_sentiment_csv = 'sentiment/' + ticker + '_vader_data.csv'
    textblob_sentiment_csv = 'sentiment/' + ticker + '_textblob_data.csv'
    
    #read spreadsheet
    df_vader = pd.read_csv(vader_sentiment_csv)
    df_textblob = pd.read_csv(textblob_sentiment_csv)
    #get all dates
    vader_dates = df_vader.loc[:, "Date"]
    textblob_dates = df_textblob.loc[:, "Date"]
    #values to track
    vader_average_weekly_scores = []
    textblob_average_weekly_scores = []
    weekly_dates = []
    vader_colours = []
    textblob_colours = []
    current_score = 0
    count = 0
    current_week_number = 0


    running_datetime = datetime.datetime(2021, 4, 5)
    #get every weekly date for the graph plot
    for i in range(45):
        weekly_dates.append(running_datetime.strftime("%d/%m"))
        running_datetime = running_datetime + datetime.timedelta(days = 7)

    #vader sentiment run
    for i in range(len(vader_dates)):
        #get date and check if it is in the current week
        date = df_vader.loc[i, "Date"]
        date = date.split("/")
        if(int(date[2]) < 1000):
            date[2] = "20" + date[2]
        week_datetime = datetime.date(int(date[2]), int(date[1]), int(date[0]))
        week_number = week_datetime.isocalendar()[1]
        if i == 0:
            current_week_number = datetime.datetime(2021, 4, 5).isocalendar()[1]
        else:
            #if it is not in the current week, reset all values and calculate average for
            #vader
            if week_number != current_week_number:
                #if dates from headlines are in wrong order, ignore that entry
                if week_number != 1:
                    if week_number < current_week_number:
                        continue
                vader_average_weekly_scores.append(current_score / count)
                #colours for graph
                if current_score / count < 0:
                    vader_colours.append("red")
                else:
                    vader_colours.append("green")
                count = 0
                current_score = 0
                for i in range(week_number - current_week_number - 1):
                    #if there is a week with no data then append 0
                    vader_average_weekly_scores.append(0)
                    vader_colours.append("green")
                current_week_number = week_number

        #add vader score to current week       
        current_score += df_vader["Sentiment Score"][i]
        count += 1
        if i == len(vader_dates) - 1:
            #if we have reached the end, append the average score
            vader_average_weekly_scores.append(current_score / count)
            if current_score / count < 0:
               vader_colours.append("red")
            else:
                vader_colours.append("green")
            for i in range(week_number - current_week_number - 1):
                #if there is a week with no data then append 0
                vader_average_weekly_scores.append(0)
                vader_colours.append("green")

    #reset variables for use with textblob
    current_score = 0
    count = 0
    current_week_number = 0

    #textblob run
    for i in range(len(textblob_dates)):
        #get date and check if it is in the current week
        date = df_textblob.loc[i, "Date"]
        date = date.split("/")
        if(int(date[2]) < 1000):
            date[2] = "20" + date[2]
        week_datetime = datetime.date(int(date[2]), int(date[1]), int(date[0]))
        week_number = week_datetime.isocalendar()[1]
        if i == 0:
            current_week_number = datetime.datetime(2021, 4, 5).isocalendar()[1]
        else:
            #if it is not in the current week, reset all values and calculate average for
            #textblob
            if week_number != current_week_number:
                #if dates from headlines are in wrong order, ignore that entry
                if week_number != 1:
                    if week_number < current_week_number:
                        continue
                textblob_average_weekly_scores.append(current_score / count)
                if current_score / count < 0:
                    textblob_colours.append("red")
                else:
                    textblob_colours.append("green")
                count = 0
                current_score = 0
                for i in range(week_number - current_week_number - 1):
                    #if there is a week with no data then append 0
                    textblob_average_weekly_scores.append(0)
                    textblob_colours.append("green")
                current_week_number = week_number

        #add vader score to current week           
        current_score += df_textblob["Sentiment Score"][i]
        count += 1
        if i == len(textblob_dates) - 1:
            #if we have reached the end, append the average score
            textblob_average_weekly_scores.append(current_score / count)
            if current_score / count < 0:
               textblob_colours.append("red")
            else:
                textblob_colours.append("green")
            for i in range(week_number - current_week_number - 1):
                #if there is a week with no data then append 0
                textblob_average_weekly_scores.append(0)
                textblob_colours.append("green")

    #set graph size
    plt.rcParams["figure.figsize"] = (16,12)
    stock_data = get_stock_data(ticker)

    #use matplotlib to display the graph
    plt.figure()
    plt.subplot(2, 1, 1)
    plt.title(ticker + ' - Sentiment (vader)')
    plt.xlabel('Date')
    plt.ylabel('Normalised Score')
    plt.xticks(rotation = 90)
    plt.plot(weekly_dates, vader_average_weekly_scores, label='Sentiment')
    plt.plot(weekly_dates, stock_data, color='orange', label='Stock Price')
    plt.legend()
    
    plt.subplot(2, 1, 2)
    plt.title(ticker + ' - Sentiment (textblob)')
    plt.xlabel('Date')
    plt.ylabel('Normalised Score')
    plt.xticks(rotation = 90)
    plt.plot(weekly_dates, textblob_average_weekly_scores, label='Sentiment')
    plt.plot(weekly_dates, stock_data, color='orange', label='Stock Price')
    plt.legend()
    plt.tight_layout()

    #plt.show()

    #save figure to pictures directory
    plt.savefig('sentiment_pictures/' + ticker + '.png')

    vader_sentiment_array = np.array(vader_average_weekly_scores)
    textblob_sentiment_array = np.array(textblob_average_weekly_scores)
    stock_data_array = np.array(stock_data)

    #print the coefficient between sentiment(each method) and stock price.
    print('Coefficient(Vader): ' + str(np.corrcoef(vader_sentiment_array, stock_data_array)[0][1]))
    print('Coefficient(TextBlob): ' + str(np.corrcoef(textblob_sentiment_array, stock_data_array)[0][1]))



def get_stock_data(ticker):
    '''
    Function which takes in a stock ticker and retrieves an array of its closing values from a spreadsheet.
    ticker - string
    returns an array of integers
    '''
    #get stock data and normalise the values
    ticker = 'stock_prices/' + ticker
    if ticker.endswith('.csv') == False:
        ticker = ticker + '.csv' 
    #read the stock prices spreadsheet
    df = pd.read_csv(ticker)
    weekly_closes = df.loc[:, "Close"]
    max_value = weekly_closes.max()
    min_value = weekly_closes.min()
    normalised_stock_values = []
    for i in range(len(weekly_closes)):
        #normalise the values so we can compare it to sentiment
        normalised = (weekly_closes[i] - min_value) / (max_value - min_value)
        normalised = (normalised * 2) - 1 #get value between -0.5 and 0.5
        normalised = normalised / 2
        normalised_stock_values.append(normalised)
    return normalised_stock_values

methods = ['vader', 'textblob']
companies = ['AAPL', 'AMZN', 'BHP', 'BRK.A', 'GOOG', 'JNJ', 'NEE', 'PLD', 'UPS', 'WMT', 'XOM']

for company in companies:
    #apply function to each company
    print('----------------------')
    print(company)
    display_ticker_data(company)
    print('----------------------')